Whamcloud - gitweb
AOSP: Android: stop suppressing warnings controlled by -Wall
[tools/e2fsprogs.git] / scrub / e2scrub_all.in
index a53acba..4288b96 100644 (file)
 
 PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
 
+if (( $EUID != 0 )); then
+    echo "e2scrub_all must be run as root"
+    exit 1
+fi
+
+periodic_e2scrub=0
 scrub_all=0
 snap_size_mb=256
 reap=0
@@ -50,14 +56,8 @@ exitcode() {
        # section 22.2) and hope the admin will scan the log for what
        # actually happened.
 
-       # We have to sleep 2 seconds here because journald uses the pid to
-       # connect our log messages to the systemd service.  This is critical
-       # for capturing all the log messages if the scrub fails, because the
-       # fail service uses the service name to gather log messages for the
-       # error report.
-       if [ -n "${SERVICE_MODE}" ]; then
+       if [ -n "${SERVICE_MODE}" -a "${ret}" -ne 0 ]; then
                test "${ret}" -ne 0 && ret=1
-               sleep 2
        fi
 
        exit "${ret}"
@@ -74,25 +74,55 @@ while getopts "nrAV" opt; do
 done
 shift "$((OPTIND - 1))"
 
+# If we're in service mode and the service is not enabled via config file...
+if [ -n "${SERVICE_MODE}" -a "${periodic_e2scrub}" -ne 1 ]; then
+       # ...don't start e2scrub processes.
+       if [ "${reap}" -eq 0 ]; then
+               exitcode 0
+       fi
+
+       # ...and if we don't see any leftover e2scrub snapshots, don't
+       # run the reaping process either, because lvs can be slow.
+       if ! readlink -q -s -e /dev/mapper/*.e2scrub* > /dev/null; then
+               exitcode 0
+       fi
+fi
+
+# close file descriptor 3 (from cron) since it causes lvm to kvetch
+exec 3<&-
+
 # If some prerequisite packages are not installed, exit with a code
 # indicating success to avoid spamming the sysadmin with fail messages
 # when e2scrub_all is run out of cron or a systemd timer.
 
+if ! type mapfile >& /dev/null ; then
+    test -n "${SERVICE_MODE}" && exitcode 0
+    echo "e2scrub_all: can't find mapfile --- is bash 4.xx installed?"
+    exitcode 1
+fi
+
 if ! type lsblk >& /dev/null ; then
+    test -n "${SERVICE_MODE}" && exitcode 0
     echo "e2scrub_all: can't find lsblk --- is util-linux installed?"
-    exitcode 0
+    exitcode 1
 fi
 
 if ! type lvcreate >& /dev/null ; then
+    test -n "${SERVICE_MODE}" && exitcode 0
     echo "e2scrub_all: can't find lvcreate --- is lvm2 installed?"
-    exitcode 0
+    exitcode 1
 fi
 
 # Find scrub targets, make sure we only do this once.
 ls_scan_targets() {
-       lsblk -o NAME,MOUNTPOINT,FSTYPE -P -n -p \
-             $(lvs -o lv_path --noheadings -S "lv_active=active,lv_role=public,lv_role!=snapshot,vg_free>${snap_size_mb}") | \
-           grep FSTYPE=\"ext\[234\]\" | while read vars ; do
+    local devices=$(lvs -o lv_path --noheadings -S "lv_active=active,lv_role=public,lv_role!=snapshot,vg_free>=${snap_size_mb}")
+
+    if [ -z "$devices" ]; then
+       return 0;
+    fi
+    lsblk -o NAME,MOUNTPOINT,FSTYPE,TYPE -P -n -p $devices | \
+       grep FSTYPE=\"ext\[234\]\" | grep TYPE=\"lvm\" | \
+       while read vars ; do
                eval "${vars}"
 
                if [ "${scrub_all}" -eq 1 ] || [ -n "${MOUNTPOINT}" ]; then
@@ -103,7 +133,8 @@ ls_scan_targets() {
 
 # Find leftover scrub snapshots
 ls_reap_targets() {
-       lvs -o lv_path -S lv_role=snapshot -S lv_name=~\(e2scrub$\) --noheadings
+    lvs -o lv_path -S lv_role=snapshot -S lv_name=~\(e2scrub$\) \
+       --noheadings | sed -e 's/.e2scrub$//'
 }
 
 # Figure out what we're targeting
@@ -134,13 +165,13 @@ escape_path_for_systemd() {
 }
 
 # Scrub any mounted fs on lvm by creating a snapshot and fscking that.
-stdin="$(realpath /dev/stdin)"
-ls_targets | while read tgt; do
+mapfile -t targets < <(ls_targets)
+for tgt in "${targets[@]}"; do
        # If we're not reaping and systemd is present, try invoking the
        # systemd service.
        if [ "${reap}" -ne 1 ] && type systemctl > /dev/null 2>&1; then
                tgt_esc="$(escape_path_for_systemd "${tgt}")"
-               ${DBG} systemctl start "e2scrub@${tgt_esc}" 2> /dev/null < "${stdin}"
+               ${DBG} systemctl start "e2scrub@${tgt_esc}" 2> /dev/null
                res=$?
                if [ "${res}" -eq 0 ] || [ "${res}" -eq 1 ]; then
                        continue;
@@ -148,7 +179,7 @@ ls_targets | while read tgt; do
        fi
 
        # Otherwise use direct invocation
-       ${DBG} "@root_sbindir@/e2scrub" ${scrub_args} "${tgt}" < "${stdin}"
+       ${DBG} "@root_sbindir@/e2scrub" ${scrub_args} "${tgt}"
 done
 
 exitcode 0